<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

$sNomMaj = "MATTHIEU DEVELOPPEMENT"; 
$sNomMin = "matthieu developpement";

// retourne le nombre de caractères d'une chaîne
echo "nombre de caracteres : ".strlen($sNomMin)."<br/><br/>";


echo "le nom strtolower : ".strtolower($sNomMaj)."<br/>";// minuscules
echo "le nom strtoupper : ".strtoupper($sNomMin)."<br/>";// majuscules
echo "le nom ucfirst : ".ucfirst($sNomMin)."<br/>";// premier caractère majuscule
echo "le nom ucwords : ".ucwords($sNomMin)."<br/>";// premier caractère de chaque mot en majuscules
echo "le nom lcfirst : ".lcfirst($sNomMaj)."<br/><br/>";// premier caractère en minuscule

// comparaison de 2 chaines :  0 si elles sont égales, et un nombre positif si chaîne1 est plus grand que chaîne2
echo "comparaison strcmp : ".strcmp($sNomMaj, $sNomMin)."<br/>";// en tenant compte de la casse
echo "comparaison strcasecmp : ".strcasecmp($sNomMaj, $sNomMin)."<br/><br/>";// sans tenir compte de la casse


/*
Affichage avec sprintf

  remplissage : précise le caractère éventuellement utilisé pour le remplissage.
Le caractère par défaut est l'espace.


  alignement : précise l’alignement.
Par défaut, l’alignement est à droite. Le caractère moins ("-") permet d’obtenir un alignement à gauche.

  longueur : indique le nombre minimum de caractères de l’élément mis en forme.

  précision : indique le nombre de chiffres utilisés pour la mise en forme d'un nombre à virgule flottante (valable uniquement si l'élément associé est un nombre).

  type : donne le type de la valeur à insérer :
c : entier à remplacer par le caractère dont le code ASCII a cette valeur.
d : entier.
f : nombre à virgule flottante.
s : quelconque, à représenter comme une chaîne.


%d : nombre entier sans mise en forme particulière.

%02d : compléte avec le caractère zéro, pour une longueur de deux minimum.

%.2f : deux chiffres après le séparateur décimal.

%'.10s : compléte avec un point pour atteindre une longueur minimum de dix caractères (alignement par défaut).

%'.-10s : compléte avec un point pour atteindre une longueur minimum de dix caractères (signe - = alignement à gauche).

%'.5.2f : deux chiffres après le séparateur décimal, compléte avec un point pour atteindre une longueur minimum de cinq caractères avant le point décimal (alignement par défaut).

 */

echo "Mise en forme d'une date : ".sprintf("%02d/%02d/%04d",1,2,2014)."<br />"; 

echo "Mise en forme de nombres : ".sprintf("%01.2f - %01.2f",1/3,12345678.9)."<br />"; 

echo "Pourcentage : ".sprintf("%01.2f %%",12.3)."<br /><br/>"; 

echo "Utilisation des options de remplissage :<br />"; 

echo "<tt>"; // police non proportionnelle 
printf("%'.-10s%'.5.2f<br />", "Livres",9.35); // printf direct 
printf("%'.-10s%'.5.2f<br />", "DVD",99.9); // printf direct 
echo "</tt>";

// mise en forme d'un nombre
/*
chaîne number_format(nombre valeur[, entier décimales[, chaîne séparateur_décimal, chaîne séparateur_milliers]])

  valeur : nombre à mettre en forme.

  décimales : nombre de décimales (aucune partie décimale par défaut).

  séparateur_décimal : séparateur décimal (point par défaut).

  séparateur_milliers : séparateur des milliers (virgule par défaut).

 */
$nValue = 1234.579;
echo "Formatage du nombre : ".number_format($nValue)."<br /><br/>";// affiche 1,235 
echo "Formatage du nombre : ".number_format($nValue, 1)."<br />";// affiche 1,234.5
echo "Formatage du nombre : ".number_format($nValue, 2, ',', ' ')."<br /><br />";// affiche 1 234,57


// supprime les caractères "blancs" ou d'autres caractères dans une chaine
$cValue = "\t\t\t M \n\r"; 
echo "strlen(cValue) = ".strlen($cValue)."<br />"; 
echo "strlen(ltrim(cValue)) = ".strlen(ltrim($cValue))."<br />"; 
echo "strlen(rtrim(cValue)) = ".strlen(rtrim($cValue))."<br />"; 
echo "strlen(trim(cValue)) = ".strlen(trim($cValue))."<br /><br/>"; 

$cValue = "***+-Matthieu-+***"; 
echo "trim(cValue,*+-) = ".trim($cValue,'*+-')."<br /><br/>"; 

// extraire une sous-chaîne dans une chaîne
$cValue = "Matthieu"; 
echo "substr(cValue,3) = ".substr($cValue,3)."<br />"; 
echo "substr(cValue,3,2) = ".substr($cValue,3,2)."<br />"; 
echo "substr(cValue,-4) = ".substr($cValue,-4)."<br />"; 
echo "substr(cValue,-4,3) = ".substr($cValue,-4,3)."<br /><br/>"; 

//  construit une chaîne par répétition de caractères
echo str_repeat('Matth', 3);// affiche MatthMatthMatth

// recherche la position d’une occurrence (caractère ou chaîne) à l’intérieur d’une chaîne
$sMail = "contact@programmation-facile.com"; 
$nPosition = strrpos($sMail, "@"); 
echo "@ est a la position ".$nPosition." dans ".$sMail."<br />";


// str_replace permet de remplacer les occurrences d'une chaîne par une autre chaîne. La recherche est sensible à la casse.
// str_ireplace permet la même action mais n'est pas sensible à la casse

/*
mixte str_replace(mixte rechercher, mixte remplacer, mixte à_traiter [,entier nombre]) 

mixte str_ireplace(mixte rechercher, mixed remplacer, mixed à_traiter[,entier nombre])

  rechercher : chaîne à rechercher ou tableau de chaînes à rechercher.

  remplacer : chaîne de remplacement ou tableau donnant une liste de chaînes de remplacement.

  à_traiter : chaîne à traiter ou tableau de chaînes à traiter.

  nombre : variable permettant de récupérer le nombre de remplacements.
 */

echo str_replace("oui", "non", "oui c'est cool"); // affiche non c'est cool

// remplace les occurrences d'un caractère par un autre caractère ou d'une chaîne par une autre chaîne.
$cValue = "cet été, à la plage"; 
$cAvant = "éèà"; 
$cApres = "eea"; 
echo "<b>Supprime les caracteres acccentues :</b><br />"; 
echo $cAvant." => ".$cApres."<br />"; 
echo "cValue => ".strtr($cValue, $cAvant, $cApres)."<br />"; 

echo "pas d'accents : ".removeAccents($cValue);

function removeAccents($str, $charset='utf-8')
{
    $str = htmlentities($str, ENT_NOQUOTES, $charset);
    
    $str = preg_replace('#&([A-za-z])(?:acute|cedil|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
    $str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
    $str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères
    
    return $str;
}

?>
